// ControlDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EX3.h"
#include "ControlDlg.h"
#include "EX3Dlg.h"
#include "mm.h"

static int IDC_MOTOR_CTRL[MAX_MOTOR_NO] = {
	IDC_SLIDER_RFOOT_ROLL,   IDC_SLIDER_RFOOT_PITCH,  IDC_SLIDER_RFOOT_YAW, 
	IDC_SLIDER_RLEG,
	IDC_SLIDER_RTHIGH_ROLL,  IDC_SLIDER_RTHIGH_PITCH, IDC_SLIDER_RTHIGH_YAW,
	IDC_SLIDER_LFOOT_ROLL,   IDC_SLIDER_LFOOT_PITCH,  IDC_SLIDER_LFOOT_YAW, 
	IDC_SLIDER_LLEG,
	IDC_SLIDER_LTHIGH_ROLL,  IDC_SLIDER_LTHIGH_PITCH, IDC_SLIDER_LTHIGH_YAW,
	IDC_SLIDER_WAIST_ROLL,	 IDC_SLIDER_WAIST_PITCH,  IDC_SLIDER_WAIST_YAW,
	IDC_SLIDER_HEAD_ROLL,	 IDC_SLIDER_HEAD_PITCH,	  IDC_SLIDER_HEAD_YAW,
	IDC_SLIDER_RARM_ROLL,    IDC_SLIDER_RARM_PITCH,   IDC_SLIDER_RARM_YAW,
	IDC_SLIDER_LARM_ROLL,	 IDC_SLIDER_LARM_PITCH,	  IDC_SLIDER_LARM_YAW,
	IDC_SLIDER_LELBOW,		 IDC_SLIDER_RELBOW
};

static int IDC_MOTOR_VAL[MAX_MOTOR_NO] = {
	IDC_EDIT_RFOOT_ROLL,	 IDC_EDIT_RFOOT_PITCH,	  IDC_EDIT_RFOOT_YAW,
	IDC_EDIT_RLEG,
	IDC_EDIT_RTHIGH_ROLL, 	 IDC_EDIT_RTHIGH_PITCH,   IDC_EDIT_RTHIGH_YAW,
	IDC_EDIT_LFOOT_ROLL,	 IDC_EDIT_LFOOT_PITCH,	  IDC_EDIT_LFOOT_YAW, 
	IDC_EDIT_LLEG,	
	IDC_EDIT_LTHIGH_ROLL,    IDC_EDIT_LTHIGH_PITCH,   IDC_EDIT_LTHIGH_YAW,
	IDC_EDIT_WAIST_ROLL,	 IDC_EDIT_WAIST_PITCH,	  IDC_EDIT_WAIST_YAW,
	IDC_EDIT_HEAD_ROLL,      IDC_EDIT_HEAD_PITCH,     IDC_EDIT_HEAD_YAW,
	IDC_EDIT_RARM_ROLL,		 IDC_EDIT_RARM_PITCH,	  IDC_EDIT_RARM_YAW,
	IDC_EDIT_LARM_ROLL,		 IDC_EDIT_LARM_PITCH,	  IDC_EDIT_LARM_YAW, 
	IDC_EDIT_LELBOW,		 IDC_EDIT_RELBOW
};

// CControlDlg dialog

IMPLEMENT_DYNAMIC(CControlDlg, CDialog)

CControlDlg::CControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CControlDlg::IDD, pParent)
{

}

CControlDlg::~CControlDlg()
{
}

void CControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	for (int i = 0; i < MAX_MOTOR_NO; ++i) {
		DDX_Control(pDX, IDC_MOTOR_CTRL[i], _motorSliderCtrl[i]);	
		DDX_Text(pDX, IDC_MOTOR_VAL[i], _motorVal[i]);
	}
}

BOOL CControlDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	for(int i = 0; i<MAX_MOTOR_NO; i++)
	{
		_motorSliderCtrl[i].SetRange(-89,89, TRUE);
		_motorSliderCtrl[i].SetPos(0);
		_motorVal[i].Format("%d",0);
	}
	UpdateData(FALSE);
	return true;
}


BEGIN_MESSAGE_MAP(CControlDlg, CDialog)
	ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CControlDlg message handlers
void CControlDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	CEX3Dlg* _pDlg = (CEX3Dlg*)::AfxGetMainWnd();

	CSliderCtrl *pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RFOOT_ROLL);
	_motorVal[0].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT0", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RFOOT_PITCH);
	_motorVal[1].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT0", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RFOOT_YAW);
	_motorVal[2].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT0", 2, _DEG2RAD*pSlide->GetPos());
	
	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RLEG);
	_motorVal[3].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT1", 0, _DEG2RAD*pSlide->GetPos());
	
	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RTHIGH_ROLL);
	_motorVal[4].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT2", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RTHIGH_PITCH);
	_motorVal[5].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT2", 1, _DEG2RAD*pSlide->GetPos());
	
	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RTHIGH_YAW);
	_motorVal[6].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT2", 2, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LFOOT_ROLL);
	_motorVal[7].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT3", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LFOOT_PITCH);
	_motorVal[8].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT3", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LFOOT_YAW);
	_motorVal[9].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT3", 2, _DEG2RAD*pSlide->GetPos());	

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LLEG);
	_motorVal[10].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT4", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LTHIGH_ROLL);
	_motorVal[11].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT5", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LTHIGH_PITCH);
	_motorVal[12].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT5", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LTHIGH_YAW);
	_motorVal[13].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT5", 2, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_WAIST_ROLL);
	_motorVal[14].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT6", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_WAIST_PITCH);
	_motorVal[15].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT6", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_WAIST_YAW);
	_motorVal[16].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT6", 2, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_HEAD_ROLL);
	_motorVal[17].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT7", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_HEAD_PITCH);
	_motorVal[18].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT7", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_HEAD_YAW);
	_motorVal[19].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT7", 2, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RARM_ROLL);
	_motorVal[20].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT10", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RARM_PITCH);
	_motorVal[21].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT10", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RARM_YAW);
	_motorVal[22].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT10", 2, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LARM_ROLL);
	_motorVal[23].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT11", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LARM_PITCH);
	_motorVal[24].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT11", 1, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LARM_YAW);
	_motorVal[25].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT11", 2, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_LELBOW);
	_motorVal[26].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT12", 0, _DEG2RAD*pSlide->GetPos());

	pSlide = (CSliderCtrl*) GetDlgItem(IDC_SLIDER_RELBOW);
	_motorVal[27].Format("%d",pSlide->GetPos());
	_pDlg->_ode->SetJointAngle ("JOINT13", 0, _DEG2RAD*pSlide->GetPos());


	UpdateData(FALSE);

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}


